`timescale 1ns / 1ps

module clock_divider #(parameter COUNTS=2, COUNTER_BIT_LENGTH=32) (input CLK_IN, input RST, output reg CLK_OUT);
    
    reg [COUNTER_BIT_LENGTH - 1:0] counter;
    
    always @(posedge CLK_IN or posedge RST) begin
        
        if(RST) begin
            counter <= 0;
            CLK_OUT <= 0;
        end
        else if(counter < COUNTS) begin
            counter <= counter + 1;
            CLK_OUT <= CLK_OUT;
        end
        else if(counter == COUNTS) begin
            counter <= 0;
            CLK_OUT <= ~CLK_OUT;
        end
        
        else begin
            counter <= 0;
            CLK_OUT <= 0;
        end
    
    end
endmodule

